import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
 
public class UTextComponent
{
    /*
    **  Return the current column number at the Caret Position.
    */
    public static int getColumnAtCaret(JTextComponent component)
    {
        int caretPosition = component.getCaretPosition();
        Element root = component.getDocument().getDefaultRootElement();
        int line = root.getElementIndex( caretPosition );
        int lineStart = root.getElement( line ).getStartOffset();
 
        return caretPosition - lineStart + 1;
    }
 
    /*
    **  Return the current line number at the Caret position.
    */
    public static int getLineAtCaret(JTextComponent component)
    {
        int caretPosition = component.getCaretPosition();
        Element root = component.getDocument().getDefaultRootElement();
 
        return root.getElementIndex( caretPosition ) + 1;
    }
 
    /*
    **  Return the number of lines of text.
    */
    public static int getLines(JTextComponent component)
    {
        Element root = component.getDocument().getDefaultRootElement();
        return root.getElementCount();
    }
    
}